/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cviceni.actions;

import com.opensymphony.xwork2.ModelDriven;
import com.opensymphony.xwork2.Preparable;
import com.opensymphony.xwork2.util.CreateIfNull;
import com.opensymphony.xwork2.util.Element;
import com.opensymphony.xwork2.util.KeyProperty;
import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.StringLengthFieldValidator;
import com.opensymphony.xwork2.validator.annotations.Validations;
import cviceni.model.Role;
import java.util.List;
import cviceni.model.Uzivatel;
import cviceni.services.UzivatelService;
import org.apache.struts2.interceptor.validation.SkipValidation;

/**
 *
 * @author nav79
 */
@Validations(requiredStrings=@RequiredStringValidator(fieldName="name",key="stringrequired"),
stringLengthFields=@StringLengthFieldValidator(fieldName="name",maxLength="20",key="error.maxlength"))
public class RoleAction extends Action implements ModelDriven<Role>, Preparable {


    private Role role;
    private Long id;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    UzivatelService service;

    public UzivatelService getUzivatelService() {
        return service;
    }

    public void setService(UzivatelService service) {
        this.service = service;
    }

    @Override
    public Role getModel() {
        return role;
    }

    @Override
    public void prepare() throws Exception {
        if (id == null || id == 0) {
            role = new Role();
        } else {
            role = service.findRoleById(id);
        }
    }

    @KeyProperty(value="id")
    @Element(value=cviceni.model.Role.class)
    @CreateIfNull(true)
    public List<Role> getSeznamRoli() {
        return service.getRoles();
    }


    @Override
    public String execute() throws Exception {
        return SUCCESS;
    }

    public String update() throws Exception {
        service.saveOrUpdate(role);
        addActionMessage(getText("zaznamUlozen"));
        return execute();
    }

    /** delete the user and go to a default home page */
    @SkipValidation
    public String delete() {
        service.deleteById(id);
        addActionMessage(getText("zaznamSmazan"));
        return LIST;
    }

    @SkipValidation
    public String reset() {
        return INPUT;
    }
}
