/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cviceni.actions;

import com.opensymphony.xwork2.ModelDriven;
import com.opensymphony.xwork2.Preparable;
import java.util.List;
import cviceni.model.Uzivatel;
import cviceni.services.UzivatelService;
import cviceni.util.Utils;
import org.apache.commons.lang.StringUtils;
import org.apache.struts2.interceptor.validation.SkipValidation;

/**
 *
 * @author nav79
 */
public class UzivatelAction extends Action implements ModelDriven<Uzivatel>, Preparable {


    private Uzivatel uzivatel;
    private Long id;
    private String newHeslo;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getNewHeslo() {
        return newHeslo;
    }

    public void setNewHeslo(String newHeslo) {
        this.newHeslo = newHeslo;
    }


    UzivatelService service;

    public UzivatelService getUzivatelService() {
        return service;
    }

    public void setService(UzivatelService service) {
        this.service = service;
    }

    public List<Uzivatel> getSeznamUzivatelu() {
        return service.getUzivatele();
    }

    @Override
    public Uzivatel getModel() {
        return uzivatel;
    }

    @Override
    public void prepare() throws Exception {
        if (id == null || id == 0) {
            uzivatel = new Uzivatel();
        } else {
            uzivatel = service.findUzivatelById(id);
        }
    }

    @Override
    public String execute() throws Exception {
        return SUCCESS;
    }

    public String update() throws Exception {
        if (StringUtils.isBlank(newHeslo)) {
            uzivatel.setHeslo(Utils.encode(newHeslo));
        }
        service.saveOrUpdate(uzivatel);
        addActionMessage(getText("zaznamUlozen"));
        return execute();
    }
    
    @SkipValidation
    public String delete() {
        service.deleteById(id);
        addActionMessage(getText("zaznamSmazan"));
        return LIST;
    }

    @SkipValidation
    public String reset() {
        return INPUT;
    }
}
