package cviceni.dao;

import cviceni.model.Role;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author lumi
 */
@Transactional
public class RoleDAOImpl implements RoleDAO {

    private final Logger logger = Logger.getLogger(getClass().getName());
    private EntityManager em;

    @PersistenceContext
    public void setEntityManager(EntityManager em) {
        this.em = em;
    }

    private EntityManager getEntityManager() {
        return em;
    }

    public void delete(Role u) {

        try {
            em.remove(u);
        } catch (Exception e) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", e);
        }
    }

    public Role findById(Long id) {
        Role u;
        try {
            return em.find(Role.class, id);
        } catch (Exception e) {
            logger.log(Level.SEVERE, "exception caught", e);
        }
        return null;
    }

    public List<Role> findAll() {

        try {
            Query q = em.createQuery("select u from Role u");
            return q.getResultList();
        } catch (Exception e) {
            logger.log(Level.SEVERE, "exception caught", e);
        }
        return new ArrayList<Role>();
    }

    public void persist(Role object) {
        try {
            em.persist(object);
        } catch (Exception e) {
            logger.log(Level.SEVERE, "exception caught", e);
        }
    }
}
