package cviceni.services;

import cviceni.dao.RoleDAO;
import cviceni.dao.UzivatelDAO;
import cviceni.model.EntityId;
import cviceni.model.Role;
import cviceni.model.Uzivatel;
import cviceni.util.Utils;
import java.security.NoSuchAlgorithmException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.security.auth.login.LoginException;

public class UzivatelServiceImpl implements UzivatelService {

    UzivatelDAO udao;
    RoleDAO rdao;

    public void setUzivatelDao(UzivatelDAO dao) {
        this.udao = dao;
    }

    public void setRoleDao(RoleDAO rdao) {
        this.rdao = rdao;
    }

    public void deleteById(Long id) {
        Uzivatel u = findUzivatelById(id);
        udao.delete(u);
    }

    public Uzivatel findUzivatelById(Long id) {
        return udao.findById(id);
    }

    public Role findRoleById(Long id) {
        return rdao.findById(id);
    }

    public List<Uzivatel> getUzivatele() {
        return udao.findAll();
    }

    public void saveOrUpdate(Uzivatel uziv) {
        udao.persist(uziv);
    }

    public void saveOrUpdate(Role role) {
        rdao.persist(role);
    }

    public List<Role> getRoles() {
        return rdao.findAll();
    }

    public Uzivatel login(String username, String password) throws LoginException {
        Uzivatel u = udao.findByLogin(username);
        if (u != null) {
            String pass = "";
            try {
                pass = Utils.encode(password);
            } catch (NoSuchAlgorithmException ex) {
                Logger.getLogger(UzivatelServiceImpl.class.getName()).log(Level.SEVERE, null, ex);
            }
            if (pass.equals(u.getHeslo())) {
                return u;
            } else {
                throw new LoginException("error.password");
            }
        }
        throw new LoginException("error.username");
    }
}
