package cviceni.util;

/*
 * (C) 2007 Mark Menard & Vita Rara, Inc.
 *
 * Mark Menard and Vita Rara, Inc. licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import com.opensymphony.xwork2.Action;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionEventListener;
import com.opensymphony.xwork2.ActionProxy;
import com.opensymphony.xwork2.Result;
import com.opensymphony.xwork2.interceptor.PreResultListener;
import com.opensymphony.xwork2.util.ValueStack;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.ValidationAware;
import com.opensymphony.xwork2.interceptor.AbstractInterceptor;
import com.opensymphony.xwork2.util.TextParseUtil;
import cviceni.model.Uzivatel;
import cviceni.services.UzivatelService;
import java.util.Set;
import javax.security.auth.login.LoginException;
import org.apache.commons.lang.StringUtils;
import org.apache.struts2.StrutsStatics;
import org.apache.struts2.interceptor.ParameterAware;
import org.apache.struts2.interceptor.SessionAware;

/**
 * A Struts 2 interceptor that implements a login system.
 */
public class LoginInterceptor extends AbstractInterceptor implements StrutsStatics {

    private UzivatelService uzivatelService;
    private Map<String, Object> session;
    private Set<String> excludeActions;

    @Override
    public void init() {
    }

    @Override
    public void destroy() {
    }

    public String intercept(ActionInvocation invocation) throws Exception {
        session = invocation.getInvocationContext().getSession();
        Action action = (Action) invocation.getAction();
        String actionName = invocation.getProxy().getActionName();
        String methodName = invocation.getProxy().getMethod();

        Uzivatel user = (Uzivatel) session.get(Constants.LOGGED_USER);
        if (user == null && !excludeActions.contains(actionName)) {
            return Constants.AUTHORIZE;
        } else {            
            if (action instanceof UzivatelAware) {
                ((UzivatelAware) action).setUzivatel(user);
            }
            return invocation.invoke();
        }
    }

        public void setExcludeActions(String values) {
        if (values != null) {
            this.excludeActions = TextParseUtil.commaDelimitedStringToSet(values);
        }
    }

}
