/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cviceni.util;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 *
 * @author nav79
 */
public class Utils {

    private static final String czChars = "áąâăäčćçđęëéěííîłľĺńňóôőöřŕšśşßťţúůűüýžźżÁĄÂĂÄČĆÇĐĘËÉĚÍÍÎŁĽĹŃŇÓÔŐÖŘŔŠŚŞßŤŢÚŮŰÜÝŽŹŻ";
    private static final String asChars = "aaaaacccdeeeeiiilllnnoooorrssssttuuuuyzzzAAAAACCCDEEEEIIILLLNNOOOORRSSSSTTUUUUYZZZ";

    public static String toAscii(StringBuffer str) {
        int len = str.length();
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < len; i++) {
            char ch = str.charAt(i);
            int pos = czChars.indexOf(ch);
            sb.append(pos < 0 ? ch : asChars.charAt(pos));
        }
        return sb.toString();
    }
   /**
    * Zkontroluje, zda je parametrem platné rodné číslo. Testuje se, zda
    * <ul>
    *   <li>má délku 9-10 znaků,
    *   <li>obsahuje pouze číslice (připouští se lomítko za 6. znakem
    *       a písmena velké abecedy ve druhé části čísla),
    *   <li>je dělitelné 11 (má-li délku 10),
    *   <li>prvních šest znaků reprezentuje datum.
    * </ul>
    * Nekontroluje se, zda číslo dne odpovídá konkrétnímu měsící a roku.
    * @param rc rodné číslo
    * @return true, pokud je rodné číslo platné, jinak false
    */
   public static boolean platneRodneCislo(String rc) {
      if (rc.length() < 7)
          // Nemuzu si dovolit test charAt(6)...
          return false;

      StringBuffer rodneCislo = new StringBuffer(rc);
      if (rodneCislo.charAt(6) == '/') {
         rodneCislo.deleteCharAt(6);
         rc = rodneCislo.toString();
      }

      int delka = rc.length();
      if (delka < 9 || delka > 10)
         return false;

      if (!rc.matches("[0-9]{6}[0-9A-Z]{3,4}"))
         return false;

      if (delka == 10) {
         try {
            if (Long.parseLong(rc) % 11 != 0)
               return false;
         } catch (NumberFormatException e) {}
      }

      int mesic = Integer.parseInt(rc.substring(2, 4));
      if (mesic >= 50)
         mesic -= 50;
      if (mesic < 1 || mesic > 12)
         return false;

      int den = Integer.parseInt(rc.substring(4, 6));
      if (den < 1 || den > 31)
         return false;

      return true;
   }

   /**
    * Zašifruje řetězec algoritmem MD5 a výsledek převede do textového tvaru
    * jako posloupnost hexa číslic.
    * @param pass původní řetězec
    * @return textová reprezentace zašifrovaného řetězce
    * @throws NoSuchAlgorithmException pokud se nenajde algoritmus MD5
    */
   public static String encode(String pass) throws NoSuchAlgorithmException {
      if (md == null)
         md = MessageDigest.getInstance("MD5");
      md.update(pass.getBytes());

      byte[] code = md.digest();
      StringBuffer hex = new StringBuffer(32);
      for (int i = 0; i < 16; i++) {
         int c = code[i] & 0xff;
         hex.append(Character.forDigit(c / 16, 16));
         hex.append(Character.forDigit(c % 16, 16));
      }
      return hex.toString();
   }

   private static MessageDigest md;

}
